"""Install for Bethel-Silva stuff"""
from Products.Silva.install import add_fss_directory_view
from Stylesheet import Stylesheet

def install(root):
    # create the core views from filesystem
    add_fss_directory_view(root.service_views,
                           'SilvaStylesheets', __file__, 'views')

    registerViews(root.service_view_registry)

    root.manage_permission('Add Silva Stylesheets',
                           ['Author', 'Editor', 'ChiefEditor', 'Manager'])

    mapping = root.service_metadata.getTypeMapping()
    mapping.editMappings('', [
        {'type': 'Silva Stylesheet',
        'chain': 'silva-content, silva-extra'},
        ])

    #make ss addable from the silva root
    addable = 'Silva Stylesheet'
    new_addables = root.get_silva_addables_allowed_in_publication()
    if addable not in new_addables:
        new_addables.append(addable)
        root.set_silva_addables_allowed_in_publication(new_addables)

def uninstall(root):
    unregisterViews(root.service_view_registry)
    root.service_views.manage_delObjects(['SilvaStylesheets'])
    
def is_installed(root):
    return hasattr(root.service_views, 'SilvaStylesheets')

def registerViews(reg):
    reg.register('edit', 'Silva Stylesheet', ['edit','Asset','Stylesheet'])
    reg.register('add', 'Silva Stylesheet', ['add', 'Stylesheet'])
    reg.register('public', 'Silva Stylesheet', ['public','Stylesheet','view'])

def unregisterViews(reg):
    meta_type = Stylesheet.meta_type
    reg.unregister('edit', meta_type)
    reg.unregister('public',meta_type)
    reg.unregister('add', meta_type)

